<?php

/**
 * @file
 * User page callbacks for the role_watchdog module.
 */

/**
 * Display tab page from menu callback.
 *
 * @param $account
 *   User object.
 */
function role_watchdog_history($account) {
  $rows = $rows2 = array();
  $roles = $account->roles;
  unset($roles[DRUPAL_AUTHENTICATED_RID]);
  $view_profile = user_access('access user profiles');
  
  $output = count($roles) ? '<h3>' . t('Roles') . '</h3>' . theme('item_list', array_keys(array_flip($roles))) : '';

  $sql = 'SELECT rw.action, rw.uid, rw.stamp, u.name, r.name AS role FROM {role_watchdog} rw INNER JOIN {users} u USING (uid) INNER JOIN {role} r USING (rid) WHERE rw.aid=%d ORDER BY rw.stamp DESC';
  $result = db_query($sql, $account->uid);
  while ($row = db_fetch_object($result)) {
    $rows[] = array(
      format_date($row->stamp),
      $row->role,
      $row->action ? t('added by') : t('removed by'),
      $view_profile ? l($row->name, 'user/' . $row->uid) : $row->name,
    );
  }

  if (sizeof($rows)) {
    $header = array(
      array('data' => t('Date'), 'style' => 'width: 25%;'),
      array('data' => t('Role'), 'style' => 'width: 30%;'),
      array('data' => t('Change'), 'style' => 'width: 15%;'),
      array('data' => t('User'), 'style' => 'width: 40%;')
    );

    $output .= '<h3>' . t('Role History') . '</h3>' . theme('table', $header, $rows, array('style' => 'width: 99%;'));
  }

  $sql = 'SELECT rw.action, rw.aid, rw.stamp, u.name, r.name AS role FROM {role_watchdog} rw INNER JOIN {users} u ON (rw.aid = u.uid) INNER JOIN {role} r USING (rid) WHERE rw.uid=%d ORDER BY rw.stamp DESC';
  $result = db_query($sql, $account->uid);
  while ($row = db_fetch_object($result)) {
    $rows2[] = array(
      format_date($row->stamp),
      $row->role,
      $row->action ? t('added to') : t('removed from'),
      $view_profile ? l($row->name, 'user/' . $row->aid) : $row->name,
    );
  }

  if (sizeof($rows2)) {
    $header = array(
      array('data' => t('Date'), 'style' => 'width: 25%;'),
      array('data' => t('Role'), 'style' => 'width: 30%;'),
      array('data' => t('Change'), 'style' => 'width: 15%;'),
      array('data' => t('User'), 'style' => 'width: 40%;')
    );

    $output .= '<h3>' . t('Role Changes Made') . '</h3>' . theme('table', $header, $rows2, array('style' => 'width: 99%;'));
  }

  if (!$output) $output = t('No role history found.');

  return $output;
}
